/*******************************************************************************
* File Name: HP_SEN.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_HP_SEN_H)
#define CY_ISR_HP_SEN_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void HP_SEN_Start(void);
void HP_SEN_StartEx(cyisraddress address);
void HP_SEN_Stop(void);

CY_ISR_PROTO(HP_SEN_Interrupt);

void HP_SEN_SetVector(cyisraddress address);
cyisraddress HP_SEN_GetVector(void);

void HP_SEN_SetPriority(uint8 priority);
uint8 HP_SEN_GetPriority(void);

void HP_SEN_Enable(void);
uint8 HP_SEN_GetState(void);
void HP_SEN_Disable(void);

void HP_SEN_SetPending(void);
void HP_SEN_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the HP_SEN ISR. */
#define HP_SEN_INTC_VECTOR            ((reg32 *) HP_SEN__INTC_VECT)

/* Address of the HP_SEN ISR priority. */
#define HP_SEN_INTC_PRIOR             ((reg32 *) HP_SEN__INTC_PRIOR_REG)

/* Priority of the HP_SEN interrupt. */
#define HP_SEN_INTC_PRIOR_NUMBER      HP_SEN__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable HP_SEN interrupt. */
#define HP_SEN_INTC_SET_EN            ((reg32 *) HP_SEN__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the HP_SEN interrupt. */
#define HP_SEN_INTC_CLR_EN            ((reg32 *) HP_SEN__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the HP_SEN interrupt state to pending. */
#define HP_SEN_INTC_SET_PD            ((reg32 *) HP_SEN__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the HP_SEN interrupt. */
#define HP_SEN_INTC_CLR_PD            ((reg32 *) HP_SEN__INTC_CLR_PD_REG)



#endif /* CY_ISR_HP_SEN_H */


/* [] END OF FILE */
