/*******************************************************************************
* File Name: sensor.h  
* Version 2.20
*
* Description:
*  This file contains the Alias definitions for Per-Pin APIs in cypins.h. 
*  Information on using these APIs can be found in the System Reference Guide.
*
* Note:
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_sensor_ALIASES_H) /* Pins sensor_ALIASES_H */
#define CY_PINS_sensor_ALIASES_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"


/***************************************
*              Constants        
***************************************/
#define sensor_0			(sensor__0__PC)
#define sensor_0_PS		(sensor__0__PS)
#define sensor_0_PC		(sensor__0__PC)
#define sensor_0_DR		(sensor__0__DR)
#define sensor_0_SHIFT	(sensor__0__SHIFT)
#define sensor_0_INTR	((uint16)((uint16)0x0003u << (sensor__0__SHIFT*2u)))

#define sensor_INTR_ALL	 ((uint16)(sensor_0_INTR))


#endif /* End Pins sensor_ALIASES_H */


/* [] END OF FILE */
