// ========================================
//PSoC4 ToF Sensor VL53L0X
//By Vlad Radoiu @  https://vladradoiu.wordpress.com/
// ========================================
//

#include "project.h"
#include <stdio.h>
#include <VL53L0X.h>

#define CONTINUOUS  //Use in timed(continuous) or single mode

uint16 dist = 0;

 CY_ISR( timer_isr ); // Timer1ms
 CY_ISR_PROTO( HP_SEN_Interrupt );

int data_count = 0;
int comp_count = 0;
int terget_count = 0;
int Up_Dn_com = 0;
int test;
uint16 Servo_Val;

void I2C_LCD_Initialize(){
    I2C_LCD_Function_set();
    I2C_LCD_Function_setEX();
    I2C_LCD_Internal_OSC_frequency();
    I2C_LCD_Contrast_set();
    I2C_LCD_Power_ICON_Contrast_control();
    I2C_LCD_Follower_control();
    CyDelay(200);
    I2C_LCD_Function_set();
    I2C_LCD_Display_ON_OFF_control();
    I2C_LCD_ClearDisplay();
    CyDelay(10);    
}

void I2C_LCD_Cursol_Position(uint8 row, uint8 col) {
  if(row == 0){
    I2C_LCD_SetDDRAM(0x80 + col);
  }else{
    I2C_LCD_SetDDRAM(0xC0 + col);
  }
}

void Bz_bee(uint16 n, uint16 delay){
  for(int i=1; i<=n; i++){     
    BZ_Start();    
    CyDelay(delay); 
    BZ_Stop();
    CyDelay(delay/4);
 }
}

void ServoMoter_cnt(int com){
    if (com == 1){
        PWM_2_Start();
    }
    else {
        PWM_2_Stop();
    }
    
}    


int main(void)
{
uint16 vr_val;
uint16 pwm_offset = 100;
    
    CyGlobalIntEnable; /* Enable global interrupts. */
    LED_Write(1);
    I2C_L_Start();
    I2C_LCD_Start();   
    I2C_LCD_Initialize();
    TIMER_Init();    
    isr_StartEx( timer_isr );
    HP_SEN_StartEx(HP_SEN_Interrupt);

    ADC_SAR_Seq_1_Start();
    ADC_SAR_Seq_1_StartConvert();    
    
    
    UART_Pi_Start();
    UART_Pi_UartPutString("PiSoC to Pi");
    UART_Pi_UartPutCRLF(1);
   
   
    TIMER_Start();
//    PWM_2_WriteCompare(vr_val/10 + 2850 + pwm_offset);
    PWM_2_WriteCompare(ADC_SAR_Seq_1_GetResult16(0)/4+2800);
        
    Bz_bee(1u,1000u);
    
    I2C_LCD_Cursol_Position(0,0);
    I2C_LCD_PrintString("########");
    I2C_LCD_Cursol_Position(1,0);
    I2C_LCD_PrintString("&&&&&&&&");      
    CyDelay(1000u);    
    I2C_LCD_ClearDisplay();

    I2C_LCD_Cursol_Position(0,0);
    I2C_LCD_PrintString("HELLO");
    I2C_LCD_Cursol_Position(1,0);
    I2C_LCD_PrintString("PiSOC!!");    
    
    
    Bz_bee(3,80u);
    
    I2C_Start();
    UART_Start();
//    LCD_PrintString("VL53L0X Distance");
    UART_PutString("VL53L0X Distance\n\r");
    VL53L0X_init(1); //initialize in 2.8V mode, default 500ms timeout
    
    #ifdef CONTINUOUS
    VL53L0X_startContinuous(100); // timed continuous mode, if 0 scan as fast as posible
    #endif
    
    CyDelay(50); // wait for the device to start
    
//    Lidar_calib(12);
    ServoMoter_cnt(1);
    LED_Write(0);

    I2C_LCD_ClearDisplay();
    I2C_LCD_Cursol_Position(0,0);
    I2C_LCD_PrintString("Distance");  
    PWM_2_WriteCompare(Servo_Val); 
    
    for(;;)
    {
        char jbuf[20];
        
        #ifdef CONTINUOUS
        dist = VL53L0X_readRangeContinuousMillimeters();
        #else
        dist = VL53L0X_readRangeSingleMillimeters();
        #endif

        sprintf(jbuf,"\"D%d\":%d,",data_count, dist);
        UART_PutString(jbuf);     
        UART_Pi_UartPutString(jbuf);
        I2C_LCD_Cursol_Position(1,0);
        I2C_LCD_PrintString("        ");

        I2C_LCD_Cursol_Position(1,0);
        I2C_LCD_PrintString("D");
        I2C_LCD_PrintNumber(data_count); 
        I2C_LCD_PrintString(":");        
        I2C_LCD_PrintNumber(dist);      
        data_count++;

        PWM_2_WriteCompare(ADC_SAR_Seq_1_GetResult16(0)/4+2800);
    }
}

CY_ISR( timer_isr )
{
 //  	TIMER_STATUS;     // Clear timer status
    TIMER_ClearInterrupt(TIMER_INTR_MASK_TC);
    timeout_start_ms++;
}

//CY_ISR( HP_SEN_Interrupt )
//{
//    HP_SEN_ClearPending();
//    hp_sensor_ClearInterrupt();   
//}